START_CODON = 'ATG'
STOP_CODONS = ('TAA', 'TGA', 'TAG')

dnaComp = {'G':'C', 'C':'G', 'A':'T', 'T':'A'}

dna2rna = {'G':'C', 'C':'G', 'A':'U', 'T':'A'}

dna2amino = {'TTT':'F', 'TTC':'F', 'TTA':'L', 'TTG':'L',
             'CTT':'L', 'CTC':'L', 'CTA':'L', 'CTG':'L',
             'ATT':'I', 'ATC':'I', 'ATA':'I', 'ATG':'M',
             'GTT':'V', 'GTC':'V', 'GTA':'V', 'GTG':'V',
             'TCT':'S', 'TCC':'S', 'TCA':'S', 'TCG':'S',
             'CCT':'P', 'CCC':'P', 'CCA':'P', 'CCG':'P',
             'ACT':'T', 'ACC':'T', 'ACA':'T', 'ACG':'T',
             'GCT':'A', 'GCC':'A', 'GCA':'A', 'GCG':'A',
             'TAT':'Y', 'TAC':'Y', 'TAA':'-', 'TAG':'-',
             'CAT':'H', 'CAC':'H', 'CAA':'Q', 'CAG':'Q',
             'AAT':'N', 'AAC':'N', 'AAA':'K', 'AAG':'K',
             'GAT':'D', 'GAC':'D', 'GAA':'E', 'GAG':'E',
             'TGT':'C', 'TGC':'C', 'TGA':'-', 'TGG':'W',
             'CGT':'R', 'CGC':'R', 'CGA':'R', 'CGG':'R',
             'AGT':'S', 'AGC':'S', 'AGA':'R', 'AGG':'R',
             'GGT':'G', 'GGC':'G', 'GGA':'G', 'GGG':'G',
             }

def reverse_complement(dna):
    """Return the reverse complement strand for the given dna strand."""
    other = ''              # start with an empty string
    for base in dna:
        other += dnaComp[base]
    return other[ : :-1]    # reverse the result

def transcribe(dna):
    """Return a string representing the RNA transcription of the given dna."""
    other = ''              # start with an empty string
    for base in dna:
        other += dna2rna[base]
    return other

def translate(dna):
    """Return the protein string produced by the given dna substring."""
    other = ''              # start with an empty string
    for k in range(0, len(dna)-2, 3):
        other += dna2amino[dna[k:k+3]]
    return other
